package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEDENOMINATION*/
@Entity(name="TgeneDenomination")
@Table(name="TGENEDENOMINATION")
public class TgeneDenomination extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneDenomination
*/
@EmbeddedId
private TgeneDenominationKey pk;
/**Contructor por defecto*/
public TgeneDenomination(){
}
/**Contructor de TgeneDenomination
@param pPk Clave Primaria del entity
*/
public TgeneDenomination(TgeneDenominationKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneDenomination
*/
public static TgeneDenomination find(EntityManager pEntityManager,TgeneDenominationKey pKey) throws Exception{
    TgeneDenomination obj = pEntityManager.find(TgeneDenomination.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneDenomination
@return El objeto que referencia a la Clave primaria de TgeneDenomination
*/
public TgeneDenominationKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneDenomination
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneDenomination
*/
public void setPk(TgeneDenominationKey pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneDenomination))return false;
    TgeneDenomination that = (TgeneDenomination) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneDenomination
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneDenomination
*/
public Object createInstance(){
 TgeneDenomination instance=new TgeneDenomination();	
 instance.setPk(new TgeneDenominationKey());
 return instance;
}
/**Clona la entidad TgeneDenomination
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneDenomination p=(TgeneDenomination)this.clone();
  p.setPk((TgeneDenominationKey)this.pk.cloneMe());
  return p;
}
}
